//
//  TileView.m
//  zoomdemo
//
//  Created by Michael Heyeck on 3/9/10.
//  Copyright 2010 Fair Oaks Labs, Inc.. All rights reserved.
//

#import "Path.h"
#import "PathGroup.h"
#import "TileView.h"


@implementation TileView

@synthesize delegate;


- (id)initWithFrame:(CGRect)frame
{
    if (self = [super initWithFrame:frame])
	{
        // Initialization code
    }
    return self;
}


- (id)initWithCoder:(NSCoder*)decoder
{
    if (self = [super initWithCoder:decoder])
	{
        // Initialization code
    }
    return self;
}


- (void)drawRect:(CGRect)rect
{
	CGContextRef context = UIGraphicsGetCurrentContext();

	// Rendering the paths
	CGContextConcatCTM(context, [self.delegate transformForTileView:self]);

	NSArray* pathGroups = [self.delegate pathGroupsForTileView:self];
	for (PathGroup* pg in pathGroups)
	{
		CGContextSaveGState(context);
		
		CGContextConcatCTM(context, pg.modelTransform);
		
		for (Path* p in pg.paths)
		{
			[p renderToContext:context];
		}
		
		CGContextRestoreGState(context);
	}
}


- (void)dealloc
{
    [super dealloc];
}


@end
